=== debian/changelog ===
libretro-snes9x (1.53+git20160522-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:46:43 +0100

libretro-snes9x (1.53+git20160522-1) unstable; urgency=low

  * Initial release (Closes: #820643).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 12 Jun 2016 20:56:00 -0300
