=== debian/changelog ===
libretro-snes9x (1.59.2-1mx17+1) mx; urgency=medium

  * Repackaged for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 02 Mar 2019 07:32:44 -0800
