=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: libretro-snes9x
 Section: non-free/games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
 Build-Depends: debhelper (>= 9)
 Standards-Version: 3.9.8
-Homepage: http://www.snes9x.com
+Homepage: https://github.com/snes9xgit/snes9x
 
 Package: libretro-snes9x
 Architecture: any
