## libretro-snes9x 1.61%2Bdfsg

=== libretro/Makefile ===
--- 
+++ 
@@ -135,6 +135,35 @@
 	    LDFLAGS += -static-libgcc -static-libstdc++
 	  endif
 	endif
+ 
+ # (armv8 a35, hard point, neon based) ### 
+# Playstation Classic 
+else ifeq ($(platform), classic_armv8_a35)
+	TARGET := $(TARGET_NAME)_libretro.so
+	fpic := -fPIC
+	SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
+	CXXFLAGS += -Ofast \
+	-flto=4 -fwhole-program -fuse-linker-plugin \
+	-fdata-sections -ffunction-sections -Wl,--gc-sections \
+	-fno-stack-protector -fno-ident -fomit-frame-pointer \
+	-falign-functions=1 -falign-jumps=1 -falign-loops=1 \
+	-fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
+	-fmerge-all-constants -fno-math-errno \
+	-marm -mtune=cortex-a8 -mfpu=neon-fp-armv8 -mfloat-abi=hard
+	CFLAGS += $(CXXFLAGS)
+	HAVE_NEON = 1
+	ARCH = arm
+	BUILTIN_GPU = neon
+	USE_DYNAREC = 1
+	ifeq ($(shell echo `$(CC) -dumpversion` "< 4.9" | bc -l), 1)
+	  CFLAGS += -march=armv8-a
+	else
+	  CFLAGS += -march=armv8-a
+	  # If gcc is 5.0 or later
+	  ifeq ($(shell echo `$(CC) -dumpversion` ">= 5" | bc -l), 1)
+	    LDFLAGS += -static-libgcc -static-libstdc++
+	  endif
+	endif
 #######################################
    
 # iOS
@@ -169,6 +198,20 @@
       CXXFLAGS += -miphoneos-version-min=5.0
    endif
 
+#tvOS
+else ifeq ($(platform), tvos-arm64)
+   CFLAGS += $(LTO)
+   CXXFLAGS += $(LTO)
+   LDFLAGS += $(LTO)
+   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
+   fpic := -fPIC
+   SHARED := -dynamiclib
+   ifeq ($(IOSSDK),)
+      IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
+   endif
+   CXXFLAGS += -DIOS
+   CXXFLAGS += -DARM
+
 # Theos
 else ifeq ($(platform), theos_ios)
    CFLAGS += $(LTO)
@@ -273,22 +316,6 @@
 else ifeq ($(platform), emscripten)
    TARGET := $(TARGET_NAME)_libretro_$(platform).bc
    STATIC_LINKING = 1
-
-# Genode
-else ifeq ($(platform), genode)
-   TARGET  := $(TARGET_NAME)_libretro.lib.so
-   PKG_CONFIG := genode-lib genode-stdcxx
-   CXXFLAGS += -D__GENODE__
-   CXXFLAGS += $(shell pkg-config --cflags $(PKG_CONFIG))
-
-   LDFLAGS += -shared --version-script=link.T
-   LDFLAGS += $(shell pkg-config --libs $(PKG_CONFIG))
-
-   CC  = $(shell pkg-config genode-base --variable=cc)
-   CXX = $(shell pkg-config genode-base --variable=cxx)
-   LD  = $(shell pkg-config genode-base --variable=ld)
-   AR  = $(shell pkg-config genode-base --variable=ar) -rcs
-   LIBS =
 
 # Windows MSVC 2003 Xbox 1
 else ifeq ($(platform), xbox1_msvc2003)
@@ -360,10 +387,3 @@
 	ProgramFiles86w := $(shell cmd /c "echo %PROGRAMFILES(x86)%")
 	ProgramFiles86 := $(shell cygpath "$(ProgramFiles86w)")
 
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
-	WindowsSdkDir := $(WindowsSdkDir)
-
-	WindowsSDKVersion ?= $(firstword $(foreach folder,$(subst $(subst \,/,$(WindowsSdkDir)Include/),,$(wildcard $(call fix_path,$(WindowsSdkDir)Include\*))),$(if $(wildcard $(call fix_path,$(WindowsSdkDir)Include/$(folder)/um/Windows.h)),$(folder),)))$(BACKSLASH)
