## libretro-snes9x 1.61+dfsg

=== gtk/meson_options.txt ===
option('opengl',          type: 'boolean', value: true,  description: 'Build support for OpenGL')
option('slang',           type: 'boolean', value: true,  description: 'Build support for slang-type shaders')
option('xv',              type: 'boolean', value: true,  description: 'Build support for XV')
option('portaudio',       type: 'boolean', value: true,  description: 'Build PortAudio sound driver')
option('oss',             type: 'boolean', value: true,  description: 'Build OSS sound driver')
option('alsa',            type: 'boolean', value: true,  description: 'Build ALSA sound driver')
option('pulseaudio',      type: 'boolean', value: true,  description: 'Build PulseAudio sound driver')
option('debugger',        type: 'boolean', value: true,  description: 'Enable Snes9x Debugger')
option('hq2x',            type: 'boolean', value: true,  description: 'Enable the HQ2x filters')
option('xbrz',            type: 'boolean', value: true,  description: 'Enable the xBRZ filters')
option('zlib',            type: 'boolean', value: true,  description: 'Enable gzip compression')
option('system-zip',      type: 'boolean', value: true,  description: 'Build using system minizip library')
option('screenshot',      type: 'boolean', value: true,  description: 'Enable screenshots')
option('wayland',         type: 'boolean', value: true,  description: 'Build support for Wayland')
option('dangerous-hacks', type: 'boolean', value: false, description: 'Allow dangerous hacks to be enabled')
option('appdatadir',      type: 'string' , value: '',    description: 'Snes9x-only data directory (default: datadir/snes9x)')
