=== debian/watch ===
version=4

opts=dversionmangle=s/\+dfsg// \
https://github.com/snes9xgit/snes9x/tags \
  (?:.*?/)?v?(\d[\d.]*(?:-.*)?)\.tar\.gz
