=== debian/changelog ===
libretro-snes9x (1.63+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan McDowell <noodles@earth.li>  Sat, 25 Jan 2025 17:47:56 +0000
