=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: libretro-snes9x
 Section: non-free/games
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.8
-Homepage: https://github.com/snes9xgit/snes9x
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Jonathan McDowell <noodles@earth.li>
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.6.2
+Homepage: http://www.snes9x.com
+Vcs-Browser: https://salsa.debian.org/games-team/libretro/libretro-snes9x
+Vcs-Git: https://salsa.debian.org/games-team/libretro/libretro-snes9x.git
+Rules-Requires-Root: no
+XS-Autobuild: yes
 
 Package: libretro-snes9x
 Architecture: any
